module Html(module Html,TagName,TagAttrs,TagAttr,
            attrs,noAttrs,(<>),lookupAttr,hasAttr,mapAttrs,implicit) where
import HtmlTags
import TagAttrs

type Html = [HtmlItem]
-- ^ This is a data type for HTML documents.

data HtmlItem = HtmlChars String                -- ^ plain text
	      | HtmlContext HtmlTag Html	-- ^ \<s>...\</s> (elements)
	      | HtmlCommand HtmlTag	        -- ^ \<s> (empty elements)
	      | HtmlGarbage HtmlBadTag          -- ^ saved for debugging output
	      deriving (Eq,Show)

type HtmlTag = (TagName, TagAttrs)
type HtmlBadTag = (String, TagAttrs)
--type TagName = String

garbage s = HtmlGarbage (s,noAttrs)
