-- | Http Status Codes <http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html>
module StatusCode where

data StatusCode = SC {statusCode::Int, statusMsg::String}

-- ** Successful 2xx

normalResult      = SC 200 "OK"
noContent         = SC 204 "No Content"

-- ** Redirections 3xx

movedPermanently  = SC 301 "Moved permanently"
found             = SC 302 "Found"
seeOther          = SC 303 "See other"
notModified       = SC 304 "Not modified"
temporaryRedirect = SC 307 "Temporary Redirect"

-- ** Client Error 4xx

badRequest        = SC 400 "Bad request"
authorizationRequired = SC 401 "Authorization Required"
forbidden         = SC 403 "Forbidden"
notFound          = SC 404 "Not found"
methodNotAllowed  = SC 405 "Method not allowed"
requestTimeout    = SC 408 "Request Timeout"
i'm_a_teapot      = SC 418 "I'm a teapot"       -- RFC 2324
tooManyRequests   = SC 429 "Too many requests"  -- RFC 6585

-- ** Server Error 5xx

internalError     = SC 500 "Internal Server Error"
notImplemented    = SC 501 "Not implemented"
