module HeaderNames where
import HeaderName(hn)

-- * Some common header names

-- ** Traditional Mail/News headers
from    = hn "From"
to      = hn "To"
cc      = hn "CC"
replyTo = hn "Reply-To"
subject = hn "Subject"
date    = hn "Date"
messageId = hn "Message-Id"
references = hn "References"
organization = hn "Organization"
newsgroups = hn "Newsgroups"
inReplyTo = hn "In-Reply-To"

-- ** MIME mail headers
mimeVersion   = hn "Mime-Version"
contentType   = hn "Content-Type"
contentLength = hn "Content-Length"
contentTransferEncoding = hn "Content-Transfer-Encoding"
contentDisposition = hn "Content-Disposition"

-- ** HTTP headers
userAgent       = hn "User-Agent"
cookie          = hn "Cookie"
setCookie       = hn "Set-Cookie"
authorization   = hn "Authorization"
ifModifiedSince = hn "If-Modified-Since"
lastModified    = hn "Last-Modified"
contentEncoding = hn "Content-encoding"
location        = hn "Location"
referer         = hn "Referer"
server          = hn "Server"
wwwAuthenticate = hn "WWW-Authenticate"
host            = hn "Host"
accept          = hn "Accept"
acceptLanguage  = hn "Accept-Language"
cacheControl    = hn "Cache-Control"
refresh         = hn "Refresh"
dnt             = hn "DNT" -- Do-Not-Track
